package dev.shadowsoffire.apotheosis.ench.compat;

import mezz.jei.api.recipe.category.IRecipeCategory;
import mezz.jei.api.registration.IRecipeCategoryRegistration;
import mezz.jei.api.registration.IRecipeCatalystRegistration;
import mezz.jei.api.recipe.vanilla.IVanillaRecipeFactory;
import mezz.jei.api.recipe.RecipeType;
import java.util.Collection;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import java.util.ArrayList;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.client.Minecraft;
import mezz.jei.api.ingredients.IIngredientType;
import net.minecraft.network.chat.Component;
import mezz.jei.api.constants.VanillaTypes;
import dev.shadowsoffire.apotheosis.ench.Ench;
import java.util.List;
import com.google.common.collect.ImmutableList;
import net.minecraft.world.level.block.Blocks;
import mezz.jei.api.constants.RecipeTypes;
import java.util.Map;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import com.google.common.collect.ImmutableMap;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import dev.shadowsoffire.apotheosis.Apotheosis;
import mezz.jei.api.registration.IRecipeRegistration;
import net.minecraft.resources.ResourceLocation;
import mezz.jei.api.JeiPlugin;
import mezz.jei.api.IModPlugin;

@JeiPlugin
public class EnchJEIPlugin implements IModPlugin
{
    public ResourceLocation getPluginUid() {
        return new ResourceLocation("apotheosis", "enchantment");
    }
    
    public void registerRecipes(final IRecipeRegistration reg) {
        if (!Apotheosis.enableEnch) {
            return;
        }
        final ItemStack enchDiaSword = new ItemStack((ItemLike)Items.f_42388_);
        EnchantmentHelper.m_44865_((Map)ImmutableMap.of(Enchantments.f_44977_, Integer.valueOf(1)), enchDiaSword);
        final ItemStack cursedDiaSword = new ItemStack((ItemLike)Items.f_42388_);
        EnchantmentHelper.m_44865_((Map)ImmutableMap.of(Enchantments.f_44975_, Integer.valueOf(1)), cursedDiaSword);
        final ItemStack enchBook = new ItemStack((ItemLike)Items.f_42690_);
        EnchantmentHelper.m_44865_((Map)ImmutableMap.of(Enchantments.f_44977_, Integer.valueOf(1)), enchBook);
        final IVanillaRecipeFactory factory = reg.getVanillaRecipeFactory();
        reg.addRecipes(RecipeTypes.ANVIL, (List)ImmutableList.of(factory.createAnvilRecipe(enchDiaSword, (List)ImmutableList.of(new ItemStack((ItemLike)Blocks.f_50033_)), (List)ImmutableList.of(new ItemStack((ItemLike)Items.f_42388_))), factory.createAnvilRecipe(cursedDiaSword, (List)ImmutableList.of(new ItemStack((ItemLike)Ench.Items.PRISMATIC_WEB.get())), (List)ImmutableList.of(new ItemStack((ItemLike)Items.f_42388_))), factory.createAnvilRecipe(enchDiaSword, (List)ImmutableList.of(new ItemStack((ItemLike)Ench.Items.SCRAP_TOME.get())), (List)ImmutableList.of(enchBook)), factory.createAnvilRecipe(new ItemStack((ItemLike)Blocks.f_50324_), (List)ImmutableList.of(new ItemStack((ItemLike)Blocks.f_50075_)), (List)ImmutableList.of(new ItemStack((ItemLike)Blocks.f_50322_)))));
        reg.addIngredientInfo((Object)new ItemStack((ItemLike)Blocks.f_50201_), (IIngredientType)VanillaTypes.ITEM_STACK, new Component[] { (Component)Component.m_237115_("info.apotheosis.enchanting") });
        reg.addIngredientInfo((Object)new ItemStack((ItemLike)Ench.Blocks.LIBRARY.get()), (IIngredientType)VanillaTypes.ITEM_STACK, new Component[] { (Component)Component.m_237115_("info.apotheosis.library") });
        final List<EnchantingRecipe> recipes = new ArrayList<EnchantingRecipe>(Minecraft.m_91087_().f_91073_.m_7465_().m_44013_(Apoth.RecipeTypes.INFUSION));
        recipes.sort((r1, r2) -> Float.compare(r1.getRequirements().eterna(), r2.getRequirements().eterna()));
        reg.addRecipes((RecipeType)EnchantingCategory.TYPE, (List)recipes);
    }
    
    public void registerRecipeCatalysts(final IRecipeCatalystRegistration reg) {
        if (!Apotheosis.enableEnch) {
            return;
        }
        reg.addRecipeCatalyst(new ItemStack((ItemLike)Blocks.f_50201_), new RecipeType[] { EnchantingCategory.TYPE });
    }
    
    public void registerCategories(final IRecipeCategoryRegistration reg) {
        if (!Apotheosis.enableEnch) {
            return;
        }
        reg.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new EnchantingCategory(reg.getJeiHelpers().getGuiHelper()) });
    }
}
